//
//  AlleleDB.h
//  GeneScore
//
//  Created by MJSDNAlab2 on 3/14/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "Allele.h"

@interface AlleleDB : NSObject
{
	unsigned int key;
	NSMutableArray *list;
	NSMutableArray *backup;
	
}
// initialize the arrays so they are ready to receive items
-(id)initDB;
// restore database with everything put in so far
-(void)restore;
// returns how many alleles in the database current working list
-(int)count;
// adds an allele into the database
-(void)addAlleleWithSize:(double)s Height:(int)h Area:(int)a Lane:(int)l;
// returns an array with lane = to l
-(NSMutableArray*)getLane:(int)l;
// returns an array with allele size s within a given tolerance
-(NSMutableArray*)getAlleleSize:(double)s withTol:(double)tol;
// removes all alleles from database, but doesn't purge the backup
-(void)removeAllAlleles;
// destroys the backup. if you wish to totally purge the database, call removeAllAllele and purgeBackup.
-(void)purgeBackup;
// accessing alleles in database
-(Allele*)getAlleleSize:(double)s inLane:(int)l withTol:(double)tol;
-(Allele*)getAlleleWithKey:(int)k;
-(NSMutableArray*)getAllelesInLane:(int)l inRangeLow:(double)low high:(double)high withScore:(int)score;
-(NSMutableArray*)getAllScoreAllelesWithMaybes:(BOOL)b;
-(NSMutableArray*)getAllAllelesWithScore:(int)b;
-(NSMutableArray*)getAllAllelesWithHeightLessThan:(int)d WithScore:(int)b;
-(NSMutableArray*)getAllAllelesWithHeightGreaterThan:(int)d WithScore:(int)b;
-(NSMutableArray*)getAllelesWithSize:(double)s withTol:(double)tol andScore:(int)b;
// a method to remove an allele from the database of a giving size and in a lane.
-(void)removeAlleleSize:(double)s inLane:(int)l withTol:(double)tol;
// remove an absolute data entry
-(void)removeAlleleWithKey:(int)k;
// calculate the average height size
// this gives us a basis to which to measure all the alleles by
// uses the weighted means as followed:
// (x1^2 + x2^2 + ... +xn^2)
// --------------------------
//    (x1 + x2 + ... + xn)
-(double)getWeightedHeightOfAllAlleles;
-(double)getWeightedHeightOfLane:(int)l;
-(double)getWeightedHeightOfSize:(double)s withTol:(double)tol;
// if maybes = yes, includes maybes in the calculation
-(double)getWeightedHeightOfAllScoredAlleleMaybes:(BOOL)myb;
//prints out the database in extended format
-(void)printDB;
@end
