//
//  Texture.h
//  Game Engine
//
//  Created by Holmes Futrell on Fri Apr 04 2003.
//  Copyright (c) 2003 Holmes Futrell. All rights reserved.
//

//Last modified April 9th, 2004.

#import <Cocoa/Cocoa.h>
#import <OpenGL/OpenGL.h>
#import <OpenGL/gl.h>
#import <OpenGL/glu.h>
#import <OpenGL/glext.h>

//enable ARB for multitexturing purposes
#define __ARB_ENABLE TRUE

@interface GLTexture : NSObject {

	BOOL textureIsRectangle;

    GLuint texture; 	//Storage for 1 texture
    GLenum texFormat;   // Format of texture (GL_RGB or GL_RGBA)
    NSSize texSize;     // Width and height
    char *texBytes;     // Texture data
    NSString *title;
}

+(id)initWithFile:(NSString *)filename;
+(id)initWithTGA:(NSString *)filename;
+(id)initWithResource:(NSString *)resourceName;
+(id)initWithTGAResource:(NSString *)resourceName;

-(id)loadNSImage:(NSString *)filename;
-(id)loadTGA:(NSString *)filename;
-(void)bind;
-(void)bindToTexelUnit:(int)unit;

//enable or disable spheremapping
+(void)setSphereMapping:(BOOL)newState;
-(int)alphaAtPoint:(NSPoint)point;

+(void)enableMipMapping;
+(void)disableMipMapping;
+(BOOL)isMipMapping;
+(void)setMipMapping:(BOOL)_state;
+(void)setActiveTextureARB:(int)unit;
-(NSSize)size;
- (id)loadTGA:(NSString *)filename nearFilter:(GLenum)nearFilter farFilter:(GLenum)farFilter mipMapping:(BOOL)mipMapping;

//accessors
-(NSString *)title;
-(BOOL)textureIsRectangle ;
-(BOOL)sizeIsPowerOfTwo:(NSSize)size;
@end
