/* GeneController */

#import <Cocoa/Cocoa.h>
#import "suh.h"
#import "AlleleDB.h"
#import "Chartview.h"
#import "accumdb.h"

@interface GeneController : NSResponder
{
	// exporting to sppcr variables
	id sppcrwindow;
	id sppcrtext;
	id gewindow;
	id geforun;
	int waitforge;
	id gesubmitbutton;
	
	id accwindow;
	id accumgeforun;
	id accumgesubmitbutton;
	
	id cleanupwindow;
	id cuwlessthanfield;
	id cuwgreaterthanfield;
	id cuwlanefield;
	id cuwallelefield;

	
	accumdb* raccumulator;
	
	
	id chart;
	id tabl;
	id datatext;
	id progressbar;
	id numemptylanes;
	id numones;
	id numtwos;
	int numentries;
	int numalleles;
	int *lanelist;
	int numlanes;
	int *allelesizelist;
	AlleleDB *database;
	id progenitor1,progenitor2;
	id highrange,lowrange;
	id shift;
	id stuttertol;
	id locusmatrix;
	id Maybes;
	id toggleTable;
	int isHomozygous;
	int isWorkingOnFile;
	NSMutableArray *data;
	int locustype;
	
	BOOL alreadyScored;	// used for determining if the data has been shifted
	double shiftvalue;
	
	
	// used to display output
	NSMutableArray *tblallele;
	NSMutableArray *tblallelecount;
	NSMutableArray *tblweight;
	NSMutableArray *tbllane;
	
	
	NSMutableArray *tbllanenumber;
	NSMutableArray *tbllaneallelesize;
	
}
// selects the file to be open
-(IBAction)openData:(id)sender;
// opens the file and parses the information
-(id)openFile:(NSString*)afile;
// converts the parsed data into the individual structures
-(void)convertDataTextToDataData;
// verifies input and calls scoreAlleles
-(IBAction)scoreData:(id)sender;
// actually tabulate and correlate and subjugate the data to the MAX!
-(void)scoreAlleles;

-(IBAction)printMyWindow:(id)sender;

-(IBAction)resetAccumulator:(id)sender;
-(IBAction)preAddToAccumulator:(id)sender;
-(IBAction)addToAccumulator:(id)sender;
-(IBAction)exportAccumulatedSPPCRData:(id)sender;

-(IBAction)exportSPPCRData:(id)sender;
-(IBAction)exportSPPCR2:(id)sender;

-(IBAction)cleanUpWindow:(id)sender;
-(IBAction)cleanUpLessThan:(id)sender;
-(IBAction)cleanUpGreaterThan:(id)sender;
-(IBAction)cleanUpLaneAndOrAllele:(id)sender;

-(void) clean:(NSMutableArray*)cleanupdata maybes:(NSMutableArray*)cleanupdatamaybes;


-(IBAction)toggleTable:(id)sender;

-(IBAction)toggleMaybes:(id)sender;


-(IBAction)graphSelections:(id)sender;

// a higher function to send messages to text window
-(void) markedMessageToViewedLog:(double) size Height:(int) height Lane:(int) lane mark:(int) marked;
// low end function to send message to text window
-(void) sendTextLog:(NSString*) str;

@end
